package com.gles.view.base;

import java.nio.FloatBuffer;

import android.opengl.GLES20;

/**
 * JqGL  API
 * 
 * @author qianjunping
 * 
 */
public final class JqGL {

	/**
	 * λ
	 */
	public static final float UNIT_SIZE = 1f;

	/**
	 * 򿪱ü<br>
	 * ǰչ涨ʽƵġᱻ<br>
	 * 
	 * @param isOpen
	 *            default false
	 */
	public void openBackCut(boolean isOpen) {
		if (isOpen) {
			GLES20.glEnable(GLES20.GL_CULL_FACE);
		} else {
			GLES20.glDisable(GLES20.GL_CULL_FACE);
		}
	}

	/**
	 * ˳ʱƣĬΪʱ
	 * 
	 * @param isOpen
	 *            default false
	 */
	public void openClockwiseWind(boolean isOpen) {
		// Ƿ˳ʱ,ϵͳĬʱ
		if (isOpen) {
			GLES20.glFrontFace(GLES20.GL_CW);
		} else {
			GLES20.glFrontFace(GLES20.GL_CCW);
		}
	}

	/**
	 * 任<br>
	 * ִб任ǰȽʼľֵѹջ<br>
	 */
	public static void saveSceneMatrix() {
		JqMatrixState.saveMatrix();
	}

	/**
	 * ָ任<br>
	 * ڱ任ɺ󣬽ԭѹջĳʼݣٷǰ<br>
	 */
	public static void restoreSceneMatrix() {
		JqMatrixState.restoreMatrix();
	}

	/**
	 * xyzƶľ
	 * 
	 * @param x
	 * @param y
	 * @param z
	 */
	public static void translate(float x, float y, float z) {
		JqMatrixState.translate(x, y, z);
	}

	/**
	 * xyz
	 * 
	 * @param x
	 * @param y
	 * @param z
	 */
	public static void scale(float x, float y, float z) {
		JqMatrixState.scale(x, y, z);
	}

	/**
	 *  xyzת, xyz һ,˵ϵԶһ,תĽǶΧƸе<br>
	 * 
	 * @param angle
	 *            Ƕ
	 * @param x
	 * @param y
	 * @param z
	 */
	public static void rotate(float angle, float x, float y, float z) {
		JqMatrixState.rotate(angle, x, y, z);
	}

	/**
	 * ӿ<br>
	 * еͶӰƽջӳ䵽ʾϵӿС<br>
	 * ӿҲʾָľ<br>
	 * <p>
	 *  4  xywidthheight˳Ϊϵ<br>
	 * 
	 * @param x
	 *            ΪӿھĻԵ <br>
	 * @param y
	 *            ΪӿھĻϱԵ<br>
	 * @param width
	 *            ΪӿڵĿ ,ͨ GLSufaceView Ŀȣʹ JqScene.getViewWidth() Ի<br>
	 * @param height
	 *            Ϊӿڵĸ߶ ,ͨ GLSufaceView ĸ߶ȣʹ JqScene.getViewHeight() Ի<br>
	 * 
	 */
	public static void setViewport(int x, int y, int width, int height) {

		GLES20.glViewport(x, y, width, height);

	}

	/**
	 * 
	 * 
	 * @param cx
	 *            λx
	 * @param cy
	 *            λy
	 * @param cz
	 *            λz
	 * @param tx
	 *            Ŀx
	 * @param ty
	 *            Ŀy
	 * @param tz
	 *            Ŀz
	 * @param upx
	 *            UPX
	 * @param upy
	 *            UPY
	 * @param upz
	 *            UPZ
	 */
	public static final void setCamer(float[] cameara) {

		if (cameara.length != 9) {
			throw new RuntimeException(JqGL.EXCEPTION_PARAMETER_NUMBER_OVERSTEP);
		}

		JqMatrixState.setCameraMatrix(cameara[0], cameara[1], cameara[2],
				cameara[3], cameara[4], cameara[5], cameara[6], cameara[7],
				cameara[8]);
	}

	/**
	 * ͶӰʽ <br>
	 * 
	 * @param orthogonalOrOutcrossing
	 *            ͶӰʽ֧ƽУͶӰԼ͸ӣԶͶӰ , 0 Ϊ ͶӰ1 Ϊ͸ͶӰ<br>
	 *            <p>
	 *            ע㣺<br>
	 *            1.ֻд ƽԶƽ֮ŻᱻͶӰƽ棬Ȼӳ䵽Ļϡ <br>
	 *            2.ͶӰʱ<br>
	 *            ƽľָ--ƽľ룬ľƽľʱ
	 *            ܱͶӰƽ <br>
	 *            3.ֻ͸ͶӰʱԶܸıʾСͶӰԶĴСʼղ<br>
	 * 
	 *            float left, // nearleft <br>
	 *            float right, // nearright<br>
	 *            float bottom, // nearbottom <br>
	 *            float top, // neartop<br>
	 *            float near, // near <br>
	 *            float far // far<br>
	 * 
	 * @param viewAspectRatio
	 *            ĻĿ߱, JqScene.getViewAspectRatio() 
	 * 
	 * @param near
	 *             nearľ
	 * 
	 * @param far
	 *             farľ
	 * @return
	 */
	public static final void setProjectionParams(int orthogonalOrOutcrossing,
			float viewAspectRatio, int near, int far) {

		if (orthogonalOrOutcrossing > 0) {
			// ͸ͶӰ
			JqMatrixState.setProjectOutcrossing(-viewAspectRatio,
					viewAspectRatio, -1, 1, near, far);
		} else {
			// ƽͶӰ
			JqMatrixState.setProjectOrthogonal(-viewAspectRatio,
					viewAspectRatio, -1, 1, near, far);
		}

	}

	/**
	 * <p>
	 * ƽơתŵȲͶӰȴܾ
	 * <p>
	 * 
	 * @return jqMVPMatrixWithCameraPro[]
	 */
	public static float[] getFinalMatrix() {
		return JqMatrixState.getFinalMatrix();
	}

	/**
	 * ùԴǰλ
	 * 
	 * @param x
	 * @param y
	 * @param z
	 */
	public static void setLightLocation(float x, float y, float z) {
		JqMatrixState.setLightLocation(x, y, z);
	}

	/**
	 * ȡԴλû
	 * 
	 * @return FloatBuffer
	 */
	public static FloatBuffer getLightLocationBuffer() {
		return JqMatrixState.getLightLocationBuffer();
	}

	/**
	 * ȡ任,Խ ת   ƽƵȲľ
	 * 
	 * @return
	 */
	public static float[] getChangeMatrix() {
		return JqMatrixState.getChangeMatrix();
	}

	/**
	 * ȡλ
	 */
	public static float[] getCameraLocation() {
		return JqMatrixState.getCameraLocation();
	}

	/**
	 * ȡλݻ
	 * 
	 * @return
	 */
	public static FloatBuffer getCameraLocationFloatBuffer() {
		return JqMatrixState.getCameraLocationFloatBuffer();
	}

	// constants
	public static final String EXCEPTION_VERTEXTDATA_NULL = "VertexData is null";
	public static final String EXCEPTION_PARAMETER_NUMBER_OVERSTEP = "Parameter number is wrong!";
}
