package com.gles.view.base;

import java.nio.ByteBuffer;
import java.nio.ByteOrder;
import java.nio.FloatBuffer;

import com.gles.view.graphics.Shader;

import android.opengl.GLES20;
import android.opengl.GLSurfaceView;


/**
 * ͼ 
 * 
 * @author qianjunping
 * 
 */
public abstract class JqGraphics {

	/**
	 * ɫId
	 */
	private int jqShaderProgramId = -1;

	/**
	 * ɫ
	 */
	private String jqShaderVertex;

	/**
	 * ƬԪɫ
	 */
	private String jqShaderFragment;

	public JqGraphics(GLSurfaceView mv, String vertexPath, String fragmentPath) {
		initGraphic(mv, vertexPath, fragmentPath);
	}

	/**
	 * GraphicsGroupʹ
	 * 
	 * @param mv
	 */
	public JqGraphics(GLSurfaceView mv) {

	}

	protected void initGraphic(GLSurfaceView mv, String vertexPath,
			String fragmentPath) {
		// ɫ
		loadShader(mv, vertexPath, fragmentPath);
	}

	/**
	 * 
	 * // ȡжλid<br>
	 * jqShaderVertexPositionAttrId = GLES20.glGetAttribLocation(
	 * jqShaderProgramId, "aPosition"); <br>
	 * // ȡжɫid <br>
	 * jqShaderVertexColorAttrId = GLES20.glGetAttribLocation(
	 * jqShaderProgramId, "aColor"); <br>
	 * // ȡܱ任id <br>
	 * jqShaderMVPMatrixId = GLES20.glGetUniformLocation(jqShaderProgramId,
	 * "uMVPMatrix");<br>
	 */
	public abstract void initShaderMember();

	/**
	 * 
	 * д̳ JqTextureView initGraphic();<br>
	 * <p>
	 * ʾ´Զ嶥ݣʹLoadUtilobjģе3Dͼε<code>
	 * ʼУ<br>
	 * 1.3D ͼζ<br>
	 * 2.ͼζ㷨<br>
	 * 3.ͼ<br>
	 * 4.ͼζɫ<br>
	 * <p>
	 * ʼ ݣʵ<br> 
	 * <p>
	 * <br>
	 * float UNIT_SIZE = 0.2f; <br>
	 * float vertices[] = new float[] { -4 * UNIT_SIZE, 0, 0, <br>
	 * 0, -4 * UNIT_SIZE,0, 4 * UNIT_SIZE, 0, 0 }; <br>
	 * ByteBuffer vbb = ByteBuffer.allocateDirect(vertices.length * 4);//ÿfloat ռ 4 ֽ  <br>
	 * vbb.order(ByteOrder.nativeOrder());  <br>
	 * jqVertexBuffer = vbb.asFloatBuffer();  <br>
	 * jqVertexBuffer.put(vertices);  <br>
	 * jqVertexBuffer.position(0); <br> 
	 * <p>
	 * ɫ<br> 
	 * float colors[] = new float[] { 1, 1, 1,0, 0, 0, 1, 0, 0, 1, 0, 0 }; <br> 
	 * ByteBuffer cbb =ByteBuffer.allocateDirect(colors.length * 4); <br>
	 * cbb.order(ByteOrder.nativeOrder());  <br> 
	 * jqVertexColorBuffer =cbb.asFloatBuffer(); <br> 
	 * jqVertexColorBuffer.put(colors); <br>
	 * jqVertexColorBuffer.position(0); </code>
	 */
	public abstract void initGraphicsData();

	/**
	 * ʾ
	 * <p>
	 * ByteBuffer vbb = ByteBuffer.allocateDirect(vertices.length * 4);
	 * <p>
	 * vbb.order(ByteOrder.nativeOrder());
	 * <p>
	 * jqVertexBuffer = vbb.asFloatBuffer();
	 * <p>
	 * jqVertexBuffer.put(vertices);
	 * <p>
	 * jqVertexBuffer.position(0);
	 * <p>
	 * 
	 * @param vertices
	 * @return
	 */
	public FloatBuffer createFloatBuffer(float[] data) {
		FloatBuffer tempFloatBuffer = null;
		// ÿfloat ռ4 ֽ
		ByteBuffer vbb = ByteBuffer.allocateDirect(data.length * 4);
		vbb.order(ByteOrder.nativeOrder());
		tempFloatBuffer = vbb.asFloatBuffer();
		tempFloatBuffer.put(data);
		tempFloatBuffer.position(0);
		return tempFloatBuffer;
	}

	protected ByteBuffer createByteBuffer(byte indexs[]) {
		ByteBuffer vbb = ByteBuffer.allocateDirect(indexs.length);
		// vbb.order(ByteOrder.nativeOrder());
		vbb.put(indexs);
		vbb.position(0);
		return vbb;
	}

	// ɫ
	private void loadShader(GLSurfaceView mv, String vertexPath,
			String fragmentPath) {

		// ضɫĽű
		jqShaderVertex = Shader.loadFromAssetsFile(vertexPath,
				mv.getResources());
		// ƬԪɫĽű
		jqShaderFragment = Shader.loadFromAssetsFile(fragmentPath,
				mv.getResources());
		// ڶɫƬԪɫ
		jqShaderProgramId = Shader.createProgram(jqShaderVertex,
				jqShaderFragment);

		// ʼɫԱ
		initShaderMember();
	}

	/**
	 * Լ任ȲȾ<br>
	 * <p>
	 * GLES20.glUseProgram(jqShaderProgramId); <br>
	 * // ʼ任<br>
	 * Matrix.setRotateM(jqMVPMatrix, 0, 0, 0, 1, 0); <br>
	 * // Zλ1<br>
	 * Matrix.translateM(jqMVPMatrix, 0, 0, 0, 1); <br>
	 * xת<br>
	 * Matrix.rotateM(jqMVPMatrix, 0, xAngle, 1, 0, 0);<br>
	 * <p>
	 * // uniform ֵݸɫ<br>
	 * GLES20.glUniformMatrix4fv(jqShaderMVPMatrixId, 1, false,
	 * Triangle.getFianlMatrix(mMatrix), 0);<br>
	 * <p>
	 * //  attribpointerԱݸɫ<br>
	 * GLES20.glVertexAttribPointer(jqShaderVertexPositionAttrId, 3,
	 * GLES20.GL_FLOAT, false, 3 * 4, jqVertexBuffer);<br>
	 * GLES20.glVertexAttribPointer(jqShaderVertexColorAttrId, 4,
	 * GLES20.GL_FLOAT, false, 4 * 4, jqVertexColorBuffer); <br>
	 * <p>
	 * //λ<br>
	 * GLES20.glEnableVertexAttribArray(jqShaderVertexPositionAttrId);<br>
	 * GLES20.glEnableVertexAttribArray(jqShaderVertexColorAttrId); <br>
	 * <p>
	 * //  <br>
	 * GLES20.glActiveTexture(GLES20.GL_TEXTURE0);<br>
	 * GLES20.glBindTexture(GLES20.GL_TEXTURE_2D, texId);<br>
	 * GLES20.glActiveTexture(GLES20.GL_TEXTURE1);<br>
	 * GLES20.glBindTexture(GLES20.GL_TEXTURE_2D, texIdNight);<br>
	 * GLES20.glUniform1i(uDayTexHandle, 0); <br>
	 * GLES20.glUniform1i(uNightTexHandle, 1); <br>
	 * <p>
	 * Dͼ<br>
	 * GLES20.glDrawArrays(GLES20.GL_TRIANGLES, 0, jqVertexCount);
	 */
	public abstract void onDraw(int... textureID);

	/**
	 * ȡɫid
	 * 
	 * @return jqShaderProgramId
	 */
	public int getShaderProgramId() {
		if (jqShaderProgramId == -1) {
			throw new RuntimeException("ɫ Id");
		}
		return jqShaderProgramId;
	}

	/**
	 * ȡɫԱid
	 * 
	 * @return int
	 */
	public int getShaderAttribId(String shaderAttriMeName) {
		return GLES20.glGetAttribLocation(jqShaderProgramId, shaderAttriMeName);
	}

	/**
	 * ȡɫͨ(uniform)id
	 * 
	 * @return int
	 */
	public int getShaderUniformId(String shaderUniformMeName) {
		return GLES20.glGetUniformLocation(jqShaderProgramId,
				shaderUniformMeName);
	}
}
