package com.gles.view.base;

import java.nio.ByteBuffer;
import java.nio.ByteOrder;
import java.nio.FloatBuffer;

import android.opengl.Matrix;

/**
 * 洢״̬
 * 
 * @author qianjunping
 * 
 */
public final class JqMatrixState {

	/**
	 * õܱ任<br>
	 * ѾͶӰȾϢ<br>
	 */
	private static float[] jqMVPMatrixWithCameraPro = new float[16];

	/**
	 * ƽƣתŵȲľ(3D)<br>
	 * ʹǰ {@link #setInitStack()} гʼ<br>
	 */
	private static float[] jqChangeMatrix;

	/**
	 * 4x4 ͶӰ,
	 * <p>
	 * (ƽͶӰ)͸ͶӰʹõľ
	 */
	private static float[] jqProjectionMatrix = new float[16];

	/**
	 * þ
	 * <p>
	 * 1.λ
	 * <p>
	 * 2.Ŀ
	 * <p>
	 * 3. up  (ÿ x,y,z ) λó9
	 */
	private static float[] jqCameraMatrix = new float[16];

	/**
	 * Դλãx,y,z
	 */

	private static float[] lightLocation = new float[] { -2, 0, 4 };

	/**
	 * λãx,y,z
	 */

	private static float[] cameraLocation = new float[3];

	/**
	 * 任ջ<br>
	 * Ϊı任ǽϵƽƣƵ˷ѺܴЧ
	 */
	private static float[][] mStack = new float[10][16];

	/**
	 * ջָ
	 */
	private static int stackTop = -1;

	/**
	 * ʼ任󣬲Ҹֵǰı任
	 */
	public static void setInitStack() {
		jqChangeMatrix = new float[16];
		Matrix.setRotateM(jqChangeMatrix, 0, 0, 1, 0, 0);
	}

	/**
	 * ñ任
	 * 
	 * @return
	 */
	static float[] getChangeMatrix() {
		if (jqChangeMatrix == null)
			throw new RuntimeException("In so doing before setInitStack()!");
		return jqChangeMatrix;
	}

	/**
	 * 任<br>
	 * ִб任ǰȽʼľֵѹջ
	 */
	static void saveMatrix() {

		if (jqChangeMatrix == null)
			throw new RuntimeException("In so doing before setInitStack()!");
		stackTop++;
		for (int i = 0; i < 16; i++) {
			mStack[stackTop][i] = jqChangeMatrix[i];
		}
	}

	/**
	 * ָ任<br>
	 * ڱ任ɺ󣬽ԭѹջĳʼݣٷǰ
	 */
	static void restoreMatrix() {

		if (jqChangeMatrix == null)
			throw new RuntimeException("In so doing before setInitStack()!");

		for (int i = 0; i < 16; i++) {
			jqChangeMatrix[i] = mStack[stackTop][i];
		}
		stackTop--;
	}

	/**
	 * ùԴλ
	 * 
	 * @param x
	 * @param y
	 * @param z
	 */
	static void setLightLocation(float x, float y, float z) {

		lightLocation[0] = x;
		lightLocation[1] = y;
		lightLocation[2] = z;

	}

	/**
	 * ȡԴλݻ
	 * 
	 * @return
	 */
	static FloatBuffer getLightLocationBuffer() {
		FloatBuffer tempFloatBuffer = null;
		// ÿfloat ռ4 ֽ
		ByteBuffer vbb = ByteBuffer.allocateDirect(lightLocation.length * 4);
		vbb.order(ByteOrder.nativeOrder());
		tempFloatBuffer = vbb.asFloatBuffer();
		tempFloatBuffer.put(lightLocation);
		tempFloatBuffer.position(0);
		return tempFloatBuffer;
	}

	/**
	 * xyzƶ
	 * 
	 * @param x
	 * @param y
	 * @param z
	 */
	static void translate(float x, float y, float z) {
		if (jqChangeMatrix == null)
			throw new RuntimeException("In so doing before setInitStack()!");
		Matrix.translateM(jqChangeMatrix, 0, x, y, z);
	}

	/**
	 * xyz
	 * 
	 * @param x
	 * @param y
	 * @param z
	 */
	static void scale(float x, float y, float z) {
		if (jqChangeMatrix == null)
			throw new RuntimeException("In so doing before setInitStack()!");
		Matrix.scaleM(jqChangeMatrix, 0, x, y, z);
	}

	/**
	 *  xyzת, xyz һ,˵ϵԶһ,תĽǶΧƸе<br>
	 * 
	 * @param angle
	 *            Ƕ
	 * @param x
	 * @param y
	 * @param z
	 */
	static void rotate(float angle, float x, float y, float z) {
		if (jqChangeMatrix == null)
			throw new RuntimeException("In so doing before setInitStack()!");
		if (angle == 0 && x == 0 && y == 0 && z == 0) {
			return;
		}
		Matrix.rotateM(jqChangeMatrix, 0, angle, x, y, z);
	}

	/**
	 * 
	 * 
	 * @param cx
	 *            λx
	 * @param cy
	 *            λy
	 * @param cz
	 *            λz
	 * @param tx
	 *            Ŀx
	 * @param ty
	 *            Ŀy
	 * @param tz
	 *            Ŀz
	 * @param upx
	 *            UPX
	 * @param upy
	 *            UPY
	 * @param upz
	 *            UPZ
	 */
	static void setCameraMatrix(float cx, float cy, float cz, float tx,
			float ty, float tz, float upx, float upy, float upz) {
		// λ鸳ֵ
		cameraLocation[0] = cx;
		cameraLocation[1] = cy;
		cameraLocation[2] = cz;

		Matrix.setLookAtM(jqCameraMatrix, 0, cx, cy, cz, tx, ty, tz, upx, upy,
				upz);
	}

	/**
	 * ȡλݻ
	 * 
	 * @return
	 */
	static FloatBuffer getCameraLocationFloatBuffer() {

		FloatBuffer tempFloatBuffer = null;
		// ÿfloat ռ4 ֽ
		ByteBuffer vbb = ByteBuffer.allocateDirect(cameraLocation.length * 4);
		vbb.order(ByteOrder.nativeOrder());
		tempFloatBuffer = vbb.asFloatBuffer();
		tempFloatBuffer.put(cameraLocation);
		tempFloatBuffer.position(0);
		return tempFloatBuffer;
	}

	/**
	 * ȡλ
	 */

	static float[] getCameraLocation() {
		return cameraLocation;
	}

	/**
	 * ͶӰ
	 */
	static void setProjectOrthogonal(float left, // nearleft
			float right, // nearright
			float bottom, // nearbottom
			float top, // neartop
			float near, // near
			float far // far
	) {
		Matrix.orthoM(jqProjectionMatrix, 0, left, right, bottom, top, near,
				far);
	}

	/**
	 * ԶͶӰ
	 */
	static void setProjectOutcrossing(float left, // nearleft
			float right, // nearright
			float bottom, // nearbottom
			float top, // neartop
			float near, // near
			float far // far
	) {
		Matrix.frustumM(jqProjectionMatrix, 0, left, right, bottom, top, near,
				far);
	}

	/**
	 * <p>
	 * ƽơתšҰͶӰȴܾ
	 * <p>
	 * 
	 * @return jqMVPMatrixWithCameraPro[]
	 */
	static float[] getFinalMatrix() {
		Matrix.multiplyMM(jqMVPMatrixWithCameraPro, 0, jqCameraMatrix, 0,
				jqChangeMatrix, 0);
		Matrix.multiplyMM(jqMVPMatrixWithCameraPro, 0, jqProjectionMatrix, 0,
				jqMVPMatrixWithCameraPro, 0);
		return jqMVPMatrixWithCameraPro;
	}
}
