package com.gles.view.base;

import javax.microedition.khronos.egl.EGLConfig;
import javax.microedition.khronos.opengles.GL10;

import android.content.Context;
import android.opengl.GLES20;
import android.opengl.GLSurfaceView;

/**
 * JqGLSurfaceView
 * 
 * ԭ ĬϵͶӰԼ
 * 
 * @author qianjunping
 * 
 */
public abstract class JqScene extends GLSurfaceView {

	/**
	 * GLSurfaceView ʾĿ߱<br>
	 *  SceneRenderer  onSurfaceChanged() ú󱻸ֵ ӿԼ ͶӰ<br>
	 */
	private static float viewAspectRatio = -1;

	/**
	 * ĬϵϷ Z ᷽ 5f ĿΪĵ㣬up Ϊƽy
	 */
	private float[] defaultCameraProjection = new float[] { 0, 0, 5, 0f, 0f,
			0f, 0f, 1.0f, 0.0f };

	/**
	 * ĬϾ near ľ
	 */
	private int defaultNear = 1;

	/**
	 * ĬϾ far ľ
	 */
	private int defaultFar = 100;

	/**
	 * GLSufaceView Ŀ
	 */
	private static int viewWidth = -1;

	/**
	 * GLSufaceView ĸ߶
	 */
	private static int viewHeight = -1;

	/**
	 * ֵ length 4 ,arga
	 */
	private float[] jqDrawBackground = new float[] { 0.0f, 0.0f, 0.0f, 1.0f };

	/**
	 * ҪƵview  length n
	 */
	private JqGraphics[] jqGraphics;

	/**
	 * Ⱦ
	 */
	private SceneRenderer mRenderer;

	public JqScene(Context context) {
		super(context);
		// ʹOPENGL ES2.0
		this.setEGLContextClientVersion(2);
		// Ⱦ
		mRenderer = new SceneRenderer();
		// Ⱦ
		setRenderer(mRenderer);
		// ȾģʽΪȾ
		setRenderMode(GLSurfaceView.RENDERMODE_CONTINUOUSLY);
	}

	/**
	 * 
	 * <br>
	 * ,ֻдʵ<br>
	 * <br>
	 * 򿪱ü;<br>
	 * ˳ʱ<br>
	 * <br>
	 * 
	 */
	@Deprecated
	public abstract void sceneSetting();

	/**
	 * ʼ<br>
	 * {@link #Jqscene.onSurfaceCreated()}<br>
	 * onSurfaceCreated()ô˷<br>
	 */
	public void initTexture() {

	}

	/**
	 * ҪƵ3Dͼ,Ҫͼ
	 */
	public abstract JqGraphics[] onCreateView();

	/**
	 * 
	 * ͼνӿ,ϵͳԶˢ´˽ӿ<br>
	 * ڻͼ֮ǰǷЧ<br>
	 * Ҫͼ֮ǰͼлЧ<br>
	 * 
	 * //<br>
	 * GLES20.glEnable(GLES20.GL_BLEND); <br>
	 * //û<br>
	 * GLES20.glBlendFunc(GLES20.GL_SRC_COLOR, GLES20.GL_ONE_MINUS_SRC_COLOR);<br>
	 * // رջ<br>
	 * GLES20.glDisable(GLES20.GL_BLEND);<br>
	 * 
	 * @param graphics
	 *            onCreateView view
	 */
	public abstract void onDraw(JqGraphics[] graphics);

	/**
	 * @param r
	 *            
	 * @param g
	 *            
	 * @param b
	 *            
	 * @param a
	 *            ͸
	 * @return
	 */
	public void setDrawBackground(float[] bg) {

		if (bg == null || bg.length <= 3) {
			throw new RuntimeException("Stack overflow");
		}

		for (int i = 0; i < jqDrawBackground.length; i++) {
			jqDrawBackground[i] = bg[i];
		}
	}

	/**
	 *  GLSufaceView ʾĿ߱
	 * 
	 * @return
	 */
	public static float getViewAspectRatio() {

		if (viewAspectRatio == -1) {
			throw new RuntimeException(
					"viewAspectRatio only be use after SceneRenderer. onSurfaceChanged()");
		}
		return viewAspectRatio;
	}

	public static int getViewWidth() {

		if (viewWidth == -1) {
			throw new RuntimeException(
					"viewWidth only be use after SceneRenderer. onSurfaceChanged()");
		}
		return viewWidth;
	}

	public static int getViewHeight() {

		if (viewHeight == -1) {
			throw new RuntimeException(
					"viewHeight only be use after SceneRenderer. onSurfaceChanged()");
		}
		return viewHeight;
	}

	private class SceneRenderer implements GLSurfaceView.Renderer {
		// SixPointedStar[] ha = new SixPointedStar[6];// 

		public void onDrawFrame(GL10 gl) {

			// Ȼɫ
			GLES20.glClear(GLES20.GL_DEPTH_BUFFER_BIT
					| GLES20.GL_COLOR_BUFFER_BIT);

			// ÿͻ˻ͼӿ
			onDraw(jqGraphics);
		}

		public void onSurfaceChanged(GL10 gl, int width, int height) {

			// ĬϵӿڴС
			JqGL.setViewport(0, 0, width, height);

			JqScene.viewWidth = width;
			JqScene.viewHeight = height;
			viewAspectRatio = (float) width / height;

			// ĬϵͶӰ
			JqGL.setProjectionParams(1, viewAspectRatio, defaultNear,
					defaultFar);

			// 
			sceneSetting();

			// ʼ
			initTexture();

		}

		public void onSurfaceCreated(GL10 gl, EGLConfig config) {

			// ʼ任
			JqMatrixState.setInitStack();

			// 
			JqGL.setCamer(defaultCameraProjection);

			// ĻɫRGBA
			GLES20.glClearColor(jqDrawBackground[0], jqDrawBackground[1],
					jqDrawBackground[2], jqDrawBackground[3]);

			jqGraphics = onCreateView();

			// ʼͼ
			for (int i = 0; i < jqGraphics.length; i++) {
				if (jqGraphics[i] != null) {
					jqGraphics[i].initGraphicsData();
				}
			}
			// ȼ
			GLES20.glEnable(GLES20.GL_DEPTH_TEST);

		}
	}
}
